Skip to main content
POST
/
v2
/
payment_intents
/
{id}
Update a PaymentIntent
curl --request POST \
  --url https://api-sandbox.uqpaytech.com/api/v2/payment_intents/{id} \
  --header 'Content-Type: application/json' \
  --header 'x-auth-token: <api-key>' \
  --header 'x-client-id: <x-client-id>' \
  --header 'x-idempotency-key: <x-idempotency-key>' \
  --data '
{
  "amount": "<string>",
  "currency": "<string>",
  "customer_id": "<string>",
  "payment_orders": {
    "type": "physical_goods",
    "products": [
      {
        "name": "<string>",
        "price": "<string>",
        "quantity": 123,
        "image_url": "<string>"
      }
    ]
  },
  "merchant_order_id": "<string>",
  "description": "<string>",
  "metadata": {
    "key1": "value1",
    "key2": "value2"
  },
  "return_url": "<string>"
}
'
{
  "payment_intent_id": "b1c2d3e4-f5a6-b7c8-d9e0-f1a2b3c4d5e6",
  "amount": "10.12",
  "currency": "SGD",
  "intent_status": "REQUIRES_PAYMENT_METHOD",
  "description": "<string>",
  "available_payment_method_types": [
    "<string>"
  ],
  "captured_amount": "10.12",
  "cancel_time": "2024-03-01T00:00:00+08:00",
  "cancellation_reason": "Order cancelled",
  "client_secret": "eyJhbGciOiJI***********ujNdZ1DF9CqWEfF1jphxI",
  "merchant_order_id": "1bf70d90-9ed0-48ce-9370-9bd7ef6ab9ee",
  "metadata": {
    "key1": "value1",
    "key2": "value2"
  },
  "next_action": {
    "type": "redirect_to_url",
    "redirect_to_url": {
      "url": "https://example.checkout-page.com",
      "return_url": "https://example.payment-result-page.com"
    },
    "redirect_iframe": {
      "iframe": "<string>"
    },
    "display_qr_code": {
      "qr_code_url": "https://sg-acquiring-bucket-sandbox.s3.ap-southeast-1.amazonaws.com/payment/20250829/qrcode_PA1961262701099356160?X-Amz-Algorithm=AWS4-HMAC-SHA256\\u0026X-Amz-Credential=ASIAY******f987429",
      "expires_at": "2023-11-07T05:31:56Z"
    },
    "display_bank_details": {
      "bank_name": "<string>",
      "account_number": "GB71950018692652646598",
      "routing_number": "012345678"
    }
  },
  "return_url": "https://127.0.0.1:8080/api/v1/callback",
  "create_time": "2024-03-01T00:00:00+08:00",
  "complete_time": "2024-03-01T00:00:00+08:00",
  "update_time": "2024-03-01T00:00:00+08:00",
  "latest_payment_attempt": {
    "attempt_id": "24fc62b4-90d1-42e3-96ab-dd54ccc648b3",
    "amount": "9.98",
    "currency": "SGD",
    "captured_amount": "0.00",
    "refunded_amount": "0.00",
    "create_time": "2025-03-21T17:17:32+08:00",
    "update_time": "2025-03-21T17:17:32+08:00",
    "complete_time": "2024-03-01T00:00:00+08:00",
    "cancellation_reason": "Order cancelled",
    "auth_code": "A12B3C",
    "arn": "74537604221222132710572",
    "rrn": "123456789012",
    "advice_code": "01",
    "authentication_data": {
      "cvv_result": "M",
      "avs_result": "Y",
      "three_ds": {
        "three_ds_version": "2.2.0",
        "eci": "05",
        "cavv": "AAABCZIhcQAAAABZlyFxAAAAAAA=",
        "three_ds_authentication_status": "Y",
        "three_ds_cancellation_reason": "01"
      }
    },
    "payment_method": {
      "type": "card",
      "card": {
        "card_name": "john doe",
        "card_number": "541333******4047",
        "network": "visa",
        "authorization_type": "authorization",
        "brand": "visa",
        "bin": "541333",
        "last4": "4047",
        "card_type": "credit",
        "expiry_month": "12",
        "expiry_year": "2027",
        "billing": {
          "first_name": "John",
          "last_name": "Doe",
          "email": "john.doe@example.com",
          "address": {
            "country_code": "SG",
            "city": "Singapore",
            "street": "444 Orchard Rd, Midpoint Orchard, Singapore ",
            "postcode": "924011",
            "state": ""
          },
          "phone_number": "12025550123"
        },
        "auto_capture": true
      }
    },
    "failure_code": "",
    "attempt_status": "INITIATED"
  }
}

Authorizations

x-auth-token
string
header
required

The API token for login provided by UQPay.

Headers

x-on-behalf-of
string

Specifies the sub-account on whose behalf the request is made. This should be set to the account_id, which can be retrieved via the List Connected Accounts. If omitted or empty, the request is executed using the master account. More information at Connected Accounts.

x-idempotency-key
string<uuid>
required

A unique identifier (UUID) used to maintain operation idempotency, ensuring that repeated executions of the same operation do not result in unintended effects or duplication. It helps preserve data consistency in the face of network errors, retries, or failures.

x-client-id
string
required

The API client id generated by UQPAY

Path Parameters

id
string
required

The unique ID of a payment intent.

Example:

"PI1925112193204883441"

Body

application/json
amount
string
currency
string

Three-letter currency code

customer
object

Customer details pertaining to the entity executing payment for this Payment Intent shall be omitted when a customer_id parameter is specified in the request.

customer_id
string

The unique identifier of the customer must be provided when the Payment Intent is designated for recurring payments. This field should be left empty in cases where the customer remains unidentified (guest checkout) or when customer information is supplied through the customer object.

payment_orders
object

Purchase order related to this PaymentIntent

merchant_order_id
string

The merchant reference id created in merchant's system that corresponds to this PaymentIntent

Maximum string length: 36
description
string

Descriptor that will display to the customer. Maximum length is 32.

Maximum string length: 32
metadata
object

Any key-value object. Max length = 512 bytes. This must be valid JSON data.

Example:
{ "key1": "value1", "key2": "value2" }
return_url
string

The web page URL or application scheme URI to redirect the customer after payment authentication.

Maximum string length: 1024

Response

Payment intent updated successfully

payment_intent_id
string
required

Unique identifier for the PaymentIntent

Maximum string length: 36
Example:

"b1c2d3e4-f5a6-b7c8-d9e0-f1a2b3c4d5e6"

amount
string
required

Payment amount. This is the order amount you would like to charge your customer.

Example:

"10.12"

currency
string
required

Three-letter currency code

Example:

"SGD"

intent_status
enum<string>
required

Status of this PaymentIntent.

Available options:
REQUIRES_PAYMENT_METHOD,
REQUIRES_CUSTOMER_ACTION,
REQUIRES_CAPTURE,
PENDING,
SUCCEEDED,
CANCELLED,
FAILED
description
string

Descriptor while creating a PaymentIntent.

Maximum string length: 255
available_payment_method_types
string[] | null

Available payment method types for this PaymentIntent.

captured_amount
string

Amount that captured from this PaymentIntent.

Example:

"10.12"

cancel_time
string<date/time>

Last time at which this PaymentIntent was cancelled. Only present when the PaymentIntent was successfully cancelled, i.e. status is CANCELLED.

Example:

"2024-03-01T00:00:00+08:00"

cancellation_reason
string

Reason for canceling this PaymentIntent.

Example:

"Order cancelled"

client_secret
string

PaymentIntent's client secret for browser or app. Returned by PaymentIntent create API or PaymentIntent retrieve API. The provided client_secret is valid for 60 minutes.

Example:

"eyJhbGciOiJI***********ujNdZ1DF9CqWEfF1jphxI"

merchant_order_id
string

The merchant reference id created in merchant's system that corresponds to this PaymentIntent

Maximum string length: 36
Example:

"1bf70d90-9ed0-48ce-9370-9bd7ef6ab9ee"

metadata
object

Any key-value object. Max length = 512 bytes. This must be valid JSON data.

Example:
{ "key1": "value1", "key2": "value2" }
next_action
object

If present, this property tells you what actions you need to take in order for your customer to fulfill a payment using the provided source.

return_url
string

The web page URL or application scheme URI to redirect the customer after payment authentication.

Example:

"https://127.0.0.1:8080/api/v1/callback"

create_time
string<date/time>

Time at which this PaymentIntent was created.

Example:

"2024-03-01T00:00:00+08:00"

complete_time
string<date/time>

Time at which this PaymentIntent reached its final state.

Example:

"2024-03-01T00:00:00+08:00"

update_time
string<date/time>

Last time at which this PaymentIntent was updated or operated on.

Example:

"2024-03-01T00:00:00+08:00"

latest_payment_attempt
object

Latest PaymentAttempt that was created under the PaymentIntent.